<?php
/*
Plugin Name: Anti Spam Image
Plugin URI: http://maxsite.org/anti-spam-image
Description: This plugin inserts a security image for the WP comment page, requiring the poster to enter the right characters in the image.
Author: Krazy Nio (modified: MaxSite - http://maxsite.org/)
Version: 0.6
Author URI: http://maxsite.org/

Plugin URI (original): http://www.infor96.com/~nio/archives/369
Author URI (original): http://www.infor96.com/~nio/
*/
if (!class_exists('AntiSpamImage')) {
@session_start();
class AntiSpamImage
{
	var $form_div;
	
    function AntiSpamImage()
    {
		$this->form_div = strtolower(substr(md5( get_bloginfo('siteurl')  ), 3, 12));
		
        add_action('comment_form', array(&$this, 'comment_form'));	//add image and input field to comment form
        add_action('comment_post', array(&$this, 'comment_post'));	//add post comment post security code check
    }

    function comment_form()
    {
        global $wpdb, $user_ID, $_SERVER;

        // If the user is logged in, dont prompt for code
        if (isset($user_ID)) {
            return $post_ID;
        }
        ?>
<div class="secimgdiv" id="<?php echo $this->form_div ?>div">
<p><input type="text" name="<?php echo $this->form_div ?>" id="<?php echo $this->form_div ?>" size="6" maxlength="4" tabindex="4" />
<label for="<?php echo $this->form_div ?>"><img src="<?php echo $_SERVER['PHP_SELF']; ?>?image=<?php echo time(); ?>" width="180" height="25" alt="Введите этот защитный код" align="absbottom" />Защитный код (красные символы НЕ вводить!)</label>
</p>
</div>

<script language="JavaScript" type="text/javascript">
var urlinput = document.getElementById("url");
var submitp = urlinput.parentNode;
var substitution2 = document.getElementById("<?php echo $this->form_div ?>div");
submitp.appendChild(substitution2, urlinput);
</script>

<?php
        return $post_ID;
    }

    function comment_post($post_ID)
    {
        global $wpdb, $user_ID, $_POST, $_SESSION, $comment_type;

        $securitycode = $_POST[$this->form_div];
        // If the user is not logged in check the security code
        if ( !$user_ID && !$comment_type ) {
            if ( '' == $securitycode ) {
                $this->comment_rollback($post_ID); //roll back
                die( __('ОШИБКА: введите защитный код (для защиты от автоспама)') );
            }
            if ( $_SESSION['IMAGE_CODE'] != $securitycode ) {
                $this->comment_rollback($post_ID); //roll back
                die( __('Неправильно введен защитный код. Вернитесь назад и заново введите предложенный набор символов.') );
            } else {
                unset($_SESSION['IMAGE_CODE']);
            }
        }
        return $post_ID;
    }

    function comment_rollback($post_ID)
    {
        global $wpdb, $wp_version;

        $pid = $wpdb->get_var("SELECT comment_post_ID FROM {$wpdb->comments} WHERE comment_ID = {$post_ID}");
        $wpdb->query("DELETE FROM {$wpdb->comments} WHERE comment_ID = {$post_ID}"); //roll back
        if ($wp_version >= '2.0') {
            $count = $wpdb->get_var("SELECT COUNT(*) FROM {$wpdb->comments} WHERE comment_post_ID = {$pid} AND comment_approved = '1'");
            $wpdb->query( "UPDATE {$wpdb->posts} SET comment_count = {$count} WHERE ID = {$pid}" );
        }
    }

}   ///:~
}   //end if
$secimg = new AntiSpamImage();
if (isset($_GET['image']) && preg_match('/^[0-9]+$/', $_GET['image'])) {  //display image
    //@ob_clean();
    //@session_start();
    $_SESSION['IMAGE_CODE'] = str_replace(array('0', 'o'), array('1', 'p'), strtolower(substr(md5(rand()), rand(1,25), 4)));
    $char = $_SESSION['IMAGE_CODE'];
    $im = @imagecreate (180, 25)
        or die ("Cannot initialize new GD image stream!");
     
     $background_color = imagecolorallocate ($im, 255, 255, 255);
    
    //random points
    for ($i = 0; $i <= 30; $i++) {
//        $point_color = imagecolorallocate ($im, rand(80,255), rand(80,255), rand(80,255));
//        imagesetpixel($im, rand(2,180), rand(2,20), $point_color);
        
        $point_color = imagecolorallocate ($im, rand(120,255), rand(120,255), rand(120,255));
        ImageLine($im, rand(-10,180), rand(-10,25), rand(-10,180), rand(-10,25),  $point_color);
    }
    
    imagestring ($im, 5, 40, 6,  'MaxSite.org', imagecolorallocate ($im, 220, 220, 220));    
    
    // rnd
    for ($i = 0; $i < strlen($char); $i++) {
        $text_color = imagecolorallocate ($im, rand(220,255), rand(0,40), 120);
        $x = 25 + $i * 45;
        $y = rand(0, 10);
        imagechar ($im, 5, $x, $y, chr(rand(48, 90)), $text_color);
        
    }   
    


    //output characters
    for ($i = 0; $i < strlen($char); $i++) {
        $text_color = imagecolorallocate ($im, rand(0,120), rand(0,180), rand(0,180));
        $x = 5 + $i * 40 + rand(-5, 5);
        $y = rand(0, 10);
        imagechar ($im, 5, $x, $y,  $char{$i}, $text_color);
    }
    
 
    
    //ouput PNG
    header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
    //  HTTP/1.1
    header("Cache-Control: no-store, no-cache, must-revalidate");
    header("Cache-Control: post-check=0, pre-check=0", false);
    //  HTTP/1.0
    header("Pragma: no-cache");
    //  Let it more flexible!
    if (function_exists("imagepng")) {
       header("Content-type: image/png");
       imagepng($im);
    } elseif (function_exists("imagegif")) {
       header("Content-type: image/gif");
       imagegif($im);
    } elseif (function_exists("imagejpeg")) {
       header("Content-type: image/jpeg");
       imagejpeg($im);
    } else {
       die("No image support in this PHP server!");
    }
    imagedestroy ($im);    
    exit;
}   //end if
?>